<?php

/**
 * inf_reembolso actions.
 *
 * @package    controlComisiones
 * @subpackage inf_reembolso
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_reembolsoActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'COM_REEMBOLSO',
        'PROYECTOS',
        'AREA'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'PROYECTOS' =>
        array(
            'id_proyecto-id' => 'COM_REEMBOLSO'
        ),
        'AREA' =>
        array(
            'id_area_lider-id_area' => 'PROYECTOS'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'COM_REEMBOLSO' =>
        array(
            'id_reembolso' => 'id_reembolso',
            'id_proyecto' => 'id_proyecto',
            'id_anhos' => 'id_anhos',
            'no_reembolso' => 'no_reembolso',
            'fecha_reembolso' => 'fecha_reembolso',
            'estado' => 'estado',
            'fecha_anulacion' => 'fecha_anulacion',
            'motivo_anulacion' => 'motivo_anulacion',
            'observaciones' => 'observaciones',
            'doc_siif' => 'doc_siif'
        ),
        'PROYECTOS' =>
        array(
            'descripcion' => 'descripcion_cm',
            'codigo' => 'codigo_cm',
            'estado' => 'estado_cm',
            'codigo,||, - ,||,descripcion' => 'completo_cm'
        ),
        'AREA' =>
        array(
            'codigo' => 'codigo_area',
            'descripcion' => 'descripcion_area',
            'codigo,||, - ,||,descripcion' => 'completo_area'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'codigo_cm', 'id_anhos', 'no_reembolso', 'fecha_reembolso', 'estado'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'COM_REEMBOLSO' =>
        array(
            'id_reembolso,a' => array('!=' => array(-1)),
            'id_reembolso,b' => array('=' => array('id_reembolso')),
            'id_proyecto' => array('=' => array('id_proyecto')),
            'id_anhos' => array('=' => array('id_anhos')),
            'fecha_reembolso' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'no_reembolso' => array('=' => array('no_reembolso')),
            'no_comision' => array('=' => array('no_comision')),
            'doc_siif' => array('=' => array('doc_siif')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'PROYECTOS' =>
        array(
            'id_area_lider' => array('=' => array('id_area'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_reembolso'; //identificador de la tabla
    protected $id_names = array('id_reembolso'); //llave primaria
    protected $field_names = array('id_proyecto', 'id_anhos', 'no_reembolso', 'fecha_reembolso', 'estado', 'fecha_anulacion', 'motivo_anulacion', 'observaciones', 'doc_siif'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'COM_REEMBOLSO'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_reembolso'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;


        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
